# ncurses 5.9 - patch 20110521 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 5.9 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 5.9 are in the subdirectory
# 	ftp://invisible-island.net/ncurses/5.9
#
# ------------------------------------------------------------------------------
# ftp://invisible-island.net/ncurses/5.9/ncurses-5.9-20110521.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun May 22 00:54:42 UTC 2011
# ------------------------------------------------------------------------------
# NEWS                        |    5 ++++-
# dist.mk                     |    4 ++--
# menu/m_driver.c             |   10 +++++++---
# ncurses/base/wresize.c      |    9 +++++----
# ncurses/tinfo/comp_expand.c |    8 ++++----
# ncurses/tinfo/lib_setup.c   |    4 ++--
# ncurses/tinfo/lib_tparm.c   |    4 ++--
# panel/panel.priv.h          |    6 +++---
# progs/tabs.c                |    9 ++++++---
# progs/tic.c                 |   22 +++++++++++-----------
# progs/toe.c                 |    4 +++-
# progs/tset.c                |    6 +++++-
# test/ditto.c                |    7 +++++--
# test/ncurses.c              |   10 ++++++----
# test/redraw.c               |    4 ++--
# test/view.c                 |    4 +++-
# 16 files changed, 70 insertions(+), 46 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.1703 
--- ncurses-5.9-20110514+/NEWS	2011-05-14 21:49:54.000000000 +0000
+++ ncurses-5.9-20110521/NEWS	2011-05-21 19:01:38.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.1703 2011/05/14 21:49:54 tom Exp $
+-- $Id: NEWS,v 1.1704 2011/05/21 19:01:38 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,9 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20110521
+	+ fix warnings from clang 2.7 "--analyze"
+
 20110514
 	+ compiler-warning fixes in panel and progs.
 	+ modify CF_PKG_CONFIG macro, from changes to tin -TD
Index: dist.mk
Prereq:  1.816 
--- ncurses-5.9-20110514+/dist.mk	2011-05-14 17:22:21.000000000 +0000
+++ ncurses-5.9-20110521/dist.mk	2011-05-21 17:35:14.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.816 2011/05/14 17:22:21 tom Exp $
+# $Id: dist.mk,v 1.817 2011/05/21 17:35:14 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 9
-NCURSES_PATCH = 20110514
+NCURSES_PATCH = 20110521
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: menu/m_driver.c
Prereq:  1.29 
--- ncurses-5.9-20110514+/menu/m_driver.c	2010-01-23 21:20:10.000000000 +0000
+++ ncurses-5.9-20110521/menu/m_driver.c	2011-05-21 18:56:41.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2009,2010 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2010,2011 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -37,7 +37,7 @@
 
 #include "menu.priv.h"
 
-MODULE_ID("$Id: m_driver.c,v 1.29 2010/01/23 21:20:10 tom Exp $")
+MODULE_ID("$Id: m_driver.c,v 1.30 2011/05/21 18:56:41 tom Exp $")
 
 /* Macros */
 
@@ -537,7 +537,11 @@
 	result = E_UNKNOWN_COMMAND;
     }
 
-  if (E_OK == result)
+  if (item == 0)
+    {
+      result = E_BAD_STATE;
+    }
+  else if (E_OK == result)
     {
       /* Adjust the top row if it turns out that the current item unfortunately
          doesn't appear in the menu window */
Index: ncurses/base/wresize.c
Prereq:  1.34 
--- ncurses-5.9-20110514+/ncurses/base/wresize.c	2010-06-05 22:36:26.000000000 +0000
+++ ncurses-5.9-20110521/ncurses/base/wresize.c	2011-05-21 18:55:07.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2009,2010 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2010,2011 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -33,7 +33,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: wresize.c,v 1.34 2010/06/05 22:36:26 tom Exp $")
+MODULE_ID("$Id: wresize.c,v 1.35 2011/05/21 18:55:07 tom Exp $")
 
 static int
 cleanup_lines(struct ldat *data, int length)
@@ -175,9 +175,10 @@
 		for (col = 0; col <= ToCols; ++col)
 		    s[col] = win->_nc_bkgd;
 	    }
-	} else {
-	    assert(pline != 0);
+	} else if (pline != 0 && pline[win->_pary + row].text != 0) {
 	    s = &pline[win->_pary + row].text[win->_parx];
+	} else {
+	    s = 0;
 	}
 
 	if_USE_SCROLL_HINTS(new_lines[row].oldindex = row);
Index: ncurses/tinfo/comp_expand.c
Prereq:  1.21 
--- ncurses-5.9-20110514+/ncurses/tinfo/comp_expand.c	2010-01-16 17:11:23.000000000 +0000
+++ ncurses-5.9-20110521/ncurses/tinfo/comp_expand.c	2011-05-21 18:55:07.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2008,2010 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2010,2011 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -35,7 +35,7 @@
 #include <ctype.h>
 #include <tic.h>
 
-MODULE_ID("$Id: comp_expand.c,v 1.21 2010/01/16 17:11:23 tom Exp $")
+MODULE_ID("$Id: comp_expand.c,v 1.22 2011/05/21 18:55:07 tom Exp $")
 
 static int
 trailing_spaces(const char *src)
@@ -61,15 +61,15 @@
     size_t need = (2 + strlen(str)) * 4;
     int ch;
 
-#if NO_LEAKS
     if (srcp == 0) {
+#if NO_LEAKS
 	if (buffer != 0) {
 	    FreeAndNull(buffer);
 	    length = 0;
 	}
+#endif
 	return 0;
     }
-#endif
     if (buffer == 0 || need > length) {
 	if ((buffer = typeRealloc(char, length = need, buffer)) == 0)
 	      return 0;
Index: ncurses/tinfo/lib_setup.c
Prereq:  1.136 
--- ncurses-5.9-20110514+/ncurses/tinfo/lib_setup.c	2011-04-16 15:32:45.000000000 +0000
+++ ncurses-5.9-20110521/ncurses/tinfo/lib_setup.c	2011-05-21 17:35:14.000000000 +0000
@@ -47,7 +47,7 @@
 #include <locale.h>
 #endif
 
-MODULE_ID("$Id: lib_setup.c,v 1.136 2011/04/16 15:32:45 tom Exp $")
+MODULE_ID("$Id: lib_setup.c,v 1.137 2011/05/21 17:35:14 tom Exp $")
 
 /****************************************************************************
  *
@@ -547,7 +547,7 @@
     int value;
     int result = 0;
 
-    if ((env = getenv(env_name)) != 0) {
+    if (getenv(env_name) != 0) {
 	result = _nc_getenv_num(env_name);
     } else if ((value = tigetnum("U8")) >= 0) {
 	result = value;		/* use extension feature */
Index: ncurses/tinfo/lib_tparm.c
Prereq:  1.82 
--- ncurses-5.9-20110514+/ncurses/tinfo/lib_tparm.c	2011-01-15 22:19:12.000000000 +0000
+++ ncurses-5.9-20110521/ncurses/tinfo/lib_tparm.c	2011-05-21 18:11:56.000000000 +0000
@@ -42,7 +42,7 @@
 #include <ctype.h>
 #include <tic.h>
 
-MODULE_ID("$Id: lib_tparm.c,v 1.82 2011/01/15 22:19:12 tom Exp $")
+MODULE_ID("$Id: lib_tparm.c,v 1.83 2011/05/21 18:11:56 tom Exp $")
 
 /*
  *	char *
@@ -522,7 +522,7 @@
     }
 #ifdef TRACE
     if (USE_TRACEF(TRACE_CALLS)) {
-	for (i = 0; i < popcount; i++) {
+	for (i = 0; i < num_args; i++) {
 	    if (p_is_s[i] != 0)
 		save_text(", %s", _nc_visbuf(p_is_s[i]), 0);
 	    else
Index: panel/panel.priv.h
Prereq:  1.23 
--- ncurses-5.9-20110514+/panel/panel.priv.h	2009-04-11 20:33:55.000000000 +0000
+++ ncurses-5.9-20110521/panel/panel.priv.h	2011-05-21 18:55:07.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2008,2009 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2009,2011 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -26,7 +26,7 @@
  * authorization.                                                           *
  ****************************************************************************/
 
-/* $Id: panel.priv.h,v 1.23 2009/04/11 20:33:55 tom Exp $ */
+/* $Id: panel.priv.h,v 1.24 2011/05/21 18:55:07 tom Exp $ */
 
 #ifndef NCURSES_PANEL_PRIV_H
 #define NCURSES_PANEL_PRIV_H 1
@@ -160,7 +160,7 @@
 ---------------------------------------------------------------------------*/
 #define PANEL_UPDATE(pan,panstart)\
 {  PANEL* pan2 = ((panstart) ? (panstart) : _nc_bottom_panel);\
-   while(pan2) {\
+   while(pan2 && pan2->win) {\
       if ((pan2 != pan) && PANELS_OVERLAPPED(pan,pan2)) {\
         int y, ix1, ix2, iy1, iy2;\
         COMPUTE_INTERSECTION(pan, pan2, ix1, ix2, iy1, iy2);\
Index: progs/tabs.c
Prereq:  1.20 
--- ncurses-5.9-20110514+/progs/tabs.c	2011-05-14 22:34:36.000000000 +0000
+++ ncurses-5.9-20110521/progs/tabs.c	2011-05-21 18:31:21.000000000 +0000
@@ -37,7 +37,7 @@
 #define USE_LIBTINFO
 #include <progs.priv.h>
 
-MODULE_ID("$Id: tabs.c,v 1.20 2011/05/14 22:34:36 tom Exp $")
+MODULE_ID("$Id: tabs.c,v 1.21 2011/05/21 18:31:21 tom Exp $")
 
 static void usage(void) GCC_NORETURN;
 
@@ -353,7 +353,6 @@
     bool no_op = FALSE;
     int n, ch;
     NCURSES_CONST char *term_name = 0;
-    const char *mar_list = 0;	/* ignored */
     char *append = 0;
     const char *tab_list = 0;
 
@@ -446,7 +445,11 @@
 	    while ((ch = *++option) != '\0') {
 		switch (ch) {
 		case 'm':
-		    mar_list = option;
+		    /*
+		     * The "+mXXX" option is unimplemented because only the long-obsolete
+		     * att510d implements smgl, which is needed to support
+		     * this option.
+		     */
 		    break;
 		default:
 		    /* special case of relative stops separated by spaces? */
Index: progs/tic.c
Prereq:  1.149 
--- ncurses-5.9-20110514+/progs/tic.c	2011-05-14 23:24:57.000000000 +0000
+++ ncurses-5.9-20110521/progs/tic.c	2011-05-21 18:15:45.000000000 +0000
@@ -44,7 +44,7 @@
 #include <dump_entry.h>
 #include <transform.h>
 
-MODULE_ID("$Id: tic.c,v 1.149 2011/05/14 23:24:57 tom Exp $")
+MODULE_ID("$Id: tic.c,v 1.150 2011/05/21 18:15:45 tom Exp $")
 
 const char *_nc_progname = "tic";
 
@@ -339,23 +339,23 @@
 static char *
 stripped(char *src)
 {
+    char *dst = 0;
+
     while (isspace(UChar(*src)))
 	src++;
+
     if (*src != '\0') {
-	char *dst;
 	size_t len;
 
-	if ((dst = strdup(src)) == NULL)
+	if ((dst = strdup(src)) == NULL) {
 	    failed("strdup");
-
-	assert(dst != 0);
-
-	len = strlen(dst);
-	while (--len != 0 && isspace(UChar(dst[len])))
-	    dst[len] = '\0';
-	return dst;
+	} else {
+	    len = strlen(dst);
+	    while (--len != 0 && isspace(UChar(dst[len])))
+		dst[len] = '\0';
+	}
     }
-    return 0;
+    return dst;
 }
 
 static FILE *
Index: progs/toe.c
Prereq:  1.53 
--- ncurses-5.9-20110514+/progs/toe.c	2011-05-14 22:35:49.000000000 +0000
+++ ncurses-5.9-20110521/progs/toe.c	2011-05-21 18:32:13.000000000 +0000
@@ -44,7 +44,7 @@
 #include <hashed_db.h>
 #endif
 
-MODULE_ID("$Id: toe.c,v 1.53 2011/05/14 22:35:49 tom Exp $")
+MODULE_ID("$Id: toe.c,v 1.54 2011/05/21 18:32:13 tom Exp $")
 
 #define isDotname(name) (!strcmp(name, ".") || !strcmp(name, ".."))
 
@@ -61,6 +61,8 @@
 }
 #endif
 
+static void failed(const char *) GCC_NORETURN;
+
 static void
 failed(const char *msg)
 {
Index: progs/tset.c
Prereq:  1.83 
--- ncurses-5.9-20110514+/progs/tset.c	2011-05-14 22:50:45.000000000 +0000
+++ ncurses-5.9-20110521/progs/tset.c	2011-05-21 18:55:32.000000000 +0000
@@ -119,7 +119,7 @@
 #include <dump_entry.h>
 #include <transform.h>
 
-MODULE_ID("$Id: tset.c,v 1.83 2011/05/14 22:50:45 tom Exp $")
+MODULE_ID("$Id: tset.c,v 1.84 2011/05/21 18:55:32 tom Exp $")
 
 /*
  * SCO defines TIOCGSIZE and the corresponding struct.  Other systems (SunOS,
@@ -148,6 +148,10 @@
 #undef CTRL
 #define CTRL(x)	((x) & 0x1f)
 
+static void failed(const char *) GCC_NORETURN;
+static void exit_error(void) GCC_NORETURN;
+static void err(const char *,...) GCC_NORETURN;
+
 const char *_nc_progname = "tset";
 
 static TTY mode, oldmode, original;
Index: test/ditto.c
Prereq:  1.40 
--- ncurses-5.9-20110514+/test/ditto.c	2010-11-14 01:06:47.000000000 +0000
+++ ncurses-5.9-20110521/test/ditto.c	2011-05-21 18:55:07.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2009,2010 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2010,2011 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,7 +29,7 @@
 /*
  * Author: Thomas E. Dickey (1998-on)
  *
- * $Id: ditto.c,v 1.40 2010/11/14 01:06:47 tom Exp $
+ * $Id: ditto.c,v 1.41 2011/05/21 18:55:07 tom Exp $
  *
  * The program illustrates how to set up multiple screens from a single
  * program.
@@ -98,6 +98,9 @@
     DITTO *ditto;		/* data for all screens */
 } DDATA;
 
+static void failed(const char *) GCC_NORETURN;
+static void usage(void) GCC_NORETURN;
+
 static void
 failed(const char *s)
 {
Index: test/ncurses.c
Prereq:  1.367 
--- ncurses-5.9-20110514+/test/ncurses.c	2011-04-23 21:16:43.000000000 +0000
+++ ncurses-5.9-20110521/test/ncurses.c	2011-05-21 18:50:56.000000000 +0000
@@ -40,7 +40,7 @@
    Author: Eric S. Raymond <esr@snark.thyrsus.com> 1993
            Thomas E. Dickey (beginning revision 1.27 in 1996).
 
-$Id: ncurses.c,v 1.367 2011/04/23 21:16:43 tom Exp $
+$Id: ncurses.c,v 1.368 2011/05/21 18:50:56 tom Exp $
 
 ***************************************************************************/
 
@@ -1394,7 +1394,7 @@
 	if (!(termattrs() & test)) {
 	    printw(" (N/A)");
 	} else {
-	    if (ncv > 0 && (getbkgd(stdscr) & A_COLOR)) {
+	    if (ncv > 0 && stdscr && (getbkgd(stdscr) & A_COLOR)) {
 		static const chtype table[] =
 		{
 		    A_STANDOUT,
@@ -4269,8 +4269,10 @@
 
 		    neww->next = current ? current->next : 0;
 		    neww->last = current;
-		    neww->last->next = neww;
-		    neww->next->last = neww;
+		    if (neww->last != 0)
+			neww->last->next = neww;
+		    if (neww->next != 0)
+			neww->next->last = neww;
 
 		    neww->wind = getwin(fp);
 
Index: test/redraw.c
Prereq:  1.6 
--- ncurses-5.9-20110514+/test/redraw.c	2011-04-23 20:13:21.000000000 +0000
+++ ncurses-5.9-20110521/test/redraw.c	2011-05-21 18:38:35.000000000 +0000
@@ -26,7 +26,7 @@
  * authorization.                                                           *
  ****************************************************************************/
 /*
- * $Id: redraw.c,v 1.6 2011/04/23 20:13:21 tom Exp $
+ * $Id: redraw.c,v 1.7 2011/05/21 18:38:35 tom Exp $
  *
  * Demonstrate the redrawwin() and wredrawln() functions.
  * Thomas Dickey - 2006/11/4
@@ -71,7 +71,7 @@
     keypad(win, TRUE);
     getmaxyx(win, max_y, max_x);
     getbegyx(win, beg_y, beg_x);
-    while (!done) {
+    while (!done && win != 0) {
 	ch = wgetch(win);
 	getyx(win, y, x);
 	switch (ch) {
Index: test/view.c
Prereq:  1.82 
--- ncurses-5.9-20110514+/test/view.c	2011-05-14 17:43:12.000000000 +0000
+++ ncurses-5.9-20110521/test/view.c	2011-05-21 18:40:49.000000000 +0000
@@ -50,7 +50,7 @@
  * scroll operation worked, and the refresh() code only had to do a
  * partial repaint.
  *
- * $Id: view.c,v 1.82 2011/05/14 17:43:12 tom Exp $
+ * $Id: view.c,v 1.83 2011/05/21 18:40:49 tom Exp $
  */
 
 #include <test.priv.h>
@@ -121,6 +121,8 @@
 static NCURSES_CH_T **lptr;
 static int num_lines;
 
+static void usage(void) GCC_NORETURN;
+
 static void
 usage(void)
 {
